﻿/*
 * VsqCurveType.cs
 * Copyright (c) 2008-2009 kbinani
 *
 * This file is part of Boare.Lib.Vsq.
 *
 * Boare.Lib.Vsq is free software; you can redistribute it and/or
 * modify it under the terms of the BSD License.
 *
 * Boare.Lib.Vsq is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 */
namespace Boare.Lib.Vsq {

    /// <summary>
    /// vsqファイルで編集可能なカーブ・プロパティの種類
    /// </summary>
    public enum VsqCurveType : int {
        /// <summary>
        /// ベロシティ
        /// </summary>
        VEL = 0,
        /// <summary>
        /// ダイナミクス　64
        /// </summary>
        DYN,
        /// <summary>
        /// ブレシネス　0
        /// </summary>
        BRE,
        /// <summary>
        /// ブライトネス　64
        /// </summary>
        BRI,
        /// <summary>
        /// クリアネス　0
        /// </summary>
        CLE,
        /// <summary>
        /// オープニング　127
        /// </summary>
        OPE,
        /// <summary>
        /// ジェンダーファクター　64
        /// </summary>
        GEN,
        /// <summary>
        /// ポルタメントタイミング　64
        /// </summary>
        POR,
        /// <summary>
        /// ピッチベンド　0
        /// </summary>
        PIT,
        /// <summary>
        /// ピッチベンドセンシティビティ　2
        /// </summary>
        PBS,
    }

}
