﻿/*
 * VsqCurveTypeUtil.cs
 * Copyright (c) 2008-2009 kbinani
 *
 * This file is part of Boare.Lib.Vsq.
 *
 * Boare.Lib.Vsq is free software; you can redistribute it and/or
 * modify it under the terms of the BSD License.
 *
 * Boare.Lib.Vsq is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 */
namespace Boare.Lib.Vsq {

    public static class VsqCurveTypeUtil {
        public static int GetMaxValue( VsqCurveType curve_type ) {
            if ( curve_type == VsqCurveType.PIT ) {
                return 8192;
            } else if ( curve_type == VsqCurveType.PBS ) {
                return 24;
            } else {
                return 127;
            }
        }


        public static int GetMinValue( VsqCurveType curve_type ) {
            if ( curve_type == VsqCurveType.PIT ) {
                return -8192;
            } else {
                return 0;
            }
        }


        public static int GetDefaultValue( VsqCurveType curve_type ) {
            switch ( curve_type ) {
                case VsqCurveType.BRE:
                    return 0;
                case VsqCurveType.BRI:
                    return 64;
                case VsqCurveType.CLE:
                    return 0;
                case VsqCurveType.DYN:
                    return 64;
                case VsqCurveType.GEN:
                    return 64;
                case VsqCurveType.OPE:
                    return 127;
                case VsqCurveType.PBS:
                    return 2;
                case VsqCurveType.PIT:
                    return 0;
                case VsqCurveType.POR:
                    return 64;
                case VsqCurveType.VEL:
                    return 64;
            }
            return 0;
        }


        public static int IndexFromCurveType( VsqCurveType curve_type ) {
            switch ( curve_type ) {
                case VsqCurveType.DYN:
                    return 0;
                case VsqCurveType.BRE:
                    return 1;
                case VsqCurveType.BRI:
                    return 2;
                case VsqCurveType.CLE:
                    return 3;
                case VsqCurveType.OPE:
                    return 4;
                case VsqCurveType.GEN:
                    return 5;
                case VsqCurveType.POR:
                    return 6;
                case VsqCurveType.PIT:
                    return 7;
                case VsqCurveType.PBS:
                    return 8;
            }
            return -1;
        }

    }

}
