﻿/*
 * FormImportLyric.cs
 * Copyright (c) 2008-2009 kbinani
 *
 * This file is part of Boare.Cadencii.
 *
 * Boare.Cadencii is free software; you can redistribute it and/or
 * modify it under the terms of the BSD License.
 *
 * Boare.Cadencii is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 */
using System;
using System.Collections.Generic;
using System.Windows.Forms;

using Boare.Lib.AppUtil;

namespace Boare.Cadencii {

    partial class FormImportLyric : Form {
        private int m_max_notes = 1;

        public FormImportLyric( int max_notes ) {
            InitializeComponent();
            ApplyLanguage();
            string notes = (max_notes > 1) ? " [notes]" : " [note]";
            lblNotes.Text = "Max : " + max_notes + notes;
            m_max_notes = max_notes;
        }

        public void ApplyLanguage() {
            Text = _( "Import lyrics" );
            btnCancel.Text = _( "Cancel" );
            btnOK.Text = _( "OK" );
        }

        public static string _( string id ) {
            return Messaging.GetMessage( id );
        }
        
        public string[] GetLetters() {
            string tmp = "";
            for ( int i = 0; i < m_max_notes; i++ ) {
                if ( i >= txtLyrics.Lines.Length ) {
                    break;
                }
                tmp += txtLyrics.Lines[i] + " ";
            }
            string[] spl = tmp.Split( new char[] { '\n', '\t', ' ', '　', '\r' }, StringSplitOptions.RemoveEmptyEntries );
            List<string> ret = new List<string>();
            foreach ( string s in spl ) {
                char[] list = s.ToCharArray();
                string t = "";
                for ( int i = 0; i < list.Length; i++ ) {
                    if ( 0x41 <= list[i] && list[i] <= 0x176 ) {
                        t += list[i].ToString();
                    } else {
                        if ( t.Length > 0 ) {
                            ret.Add( t );
                            t = "";
                        }
                        ret.Add( list[i].ToString() );
                    }
                }
                if ( t.Length > 0 ) {
                    ret.Add( t );
                }
            }
            return ret.ToArray();
        }

        private void btnOK_Click( object sender, EventArgs e ) {
            this.DialogResult = DialogResult.OK;
        }
    }

}
