﻿/*
 * VersionHistory.cs
 * Copyright (c) 2008-2009 kbinani
 *
 * This file is part of Boare.Cadencii.
 *
 * Boare.Cadencii is free software; you can redistribute it and/or
 * modify it under the terms of the BSD License.
 *
 * Boare.Cadencii is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 */
using System.Net;
using System.Xml.Serialization;

using System.Collections.Generic;

namespace Boare.Cadencii {

    public class VersionHistory {
        public List<Version> History;

        public VersionHistory() {
            History = new List<Version>();
        }

        /// <summary>
        /// 最新のリリース情報をダウンロードします
        /// </summary>
        /// <returns></returns>
        public static VersionHistory DownloadLatestVersionInfo( string uri ) {
            HttpWebRequest req = WebRequest.Create( uri ) as HttpWebRequest;
            HttpWebResponse res = null;
            try {
                res = req.GetResponse() as HttpWebResponse;
            } catch {
                return null;
            }
            XmlSerializer xs = new XmlSerializer( typeof( VersionHistory ) );
            VersionHistory vh = null;
            try {
                vh = (VersionHistory)xs.Deserialize( res.GetResponseStream() );
                vh.History.Sort();
            } catch {
            }
            return vh;
        }
    }

}
