#include "VSTi2.h"

const int SMF_FORMAT  = 1;                // vsqStandard Midi FileƂ݂Ȃ̃o[WBA1ɌŒB
const int TIME_FORMAT = 480;              // 
const int NUM_TRACKS  = 2;                // g_ppTrackEvents̔zTCYBdllł2ɌŒB
const int DEF_TEMPO   = 500000;           // ftHg̃e|D

int           g_saBlockSize;              // g`obt@̃TCYB
int           g_sampleRate;               // TvO[gBVOCALOID2 VSTi͌ꂽTvO[g󂯕tȂBĂ44100Hzɂ
MIDI_EVENT  **g_ppTrackEvents;            // MmidiCxg̃XgBg_ppTrackEvents[0]vsq̃}X^[gbNtempô݂i[
                                          // g_ppTrackEvents[1]̓_OgbNmidii[BSendMidiōXV
HMODULE       g_dllHandle;                // Ǎdll̃nh
AEffect      *g_pAEffect;                 // Ǎdll쐬VOCALOID2̖{́BVOCALOID2ւ̑g_pAEffect->dispatcherōs
MIDI_EVENT   *g_pEvents = NULL;           // g_ppTrackEvents[0]g_ppTrackEvents[1]BSendMidiŁAg_ppTrackEvents[0]
                                          // g_ppTrackEvents[1]̗_merge_eventsōB
MIDI_EVENT   *g_pCurrentEvent;            // g_pEvents̒́AݓǍłMIDI_EVENTւ̃|C^
bool          g_midiPrepared0 = false;    // g_ppTrackEvents[0]midiCxgMς݂ǂ\tO
bool          g_midiPrepared1 = false;    // g_ppTrackEvents[1]midiCxgMς݂ǂ\tO
int           g_tcCurrent = 0;
int           g_tcPrevious = 0;
int           g_saProcessed = 0;
int           g_saTotalSamples = 0;
//int           g_saDelaySamples = 0;       // fBC[sample]
TempoInfo    *g_tempoList = NULL;
int           g_numTempoList = 0;
bool          g_cancelRequired = false;
double        g_progress = 0.0;
#ifdef _DEBUG
FILE         *g_debug_wave = NULL;
#include "PresetDataForDebug.h"
#endif



extern "C" {

    double __declspec(dllexport) GetProgress(){
#ifdef _DEBUG
        printf( "@GetProgress\n" );
        printf( "    g_progress=%f\n", g_progress );
#endif
        return g_progress;
    }


    void __declspec(dllexport) AbortRendering(){
#ifdef _DEBUG
        printf( "AboutRendering()\n" );
#endif
        g_cancelRequired = true;
    }

    int __declspec(dllexport) SetSampleRate( float sample_rate ){
        return g_pAEffect->dispatcher( g_pAEffect, effSetSampleRate, 0, 0, 0, sample_rate );
    }


    int __declspec(dllexport) MainsChanged( int status ){
        return g_pAEffect->dispatcher( g_pAEffect, effMainsChanged, 0, status, 0, 0 );
    }


    int __declspec(dllexport) SetBlockSize( int block_size ){
        return g_pAEffect->dispatcher( g_pAEffect, effSetBlockSize, 0, block_size, 0, 0 );
    }


    int __declspec(dllexport) ProcessEvents( int numEvents, VstEvent events[] ){
        VstEvents* pVstEvents = (VstEvents*)malloc( sizeof(VstEvents) + numEvents * sizeof(VstEvent*) );
        pVstEvents->numEvents = 0;
        pVstEvents->reserved = NULL;

        for( int i = 0 ; i < numEvents ; i++ ){
	        VstMidiEvent* pMidiEvent;
            pMidiEvent = (VstMidiEvent*)malloc( sizeof(VstMidiEvent) + events[i].byteSize * sizeof(BYTE) );
            pMidiEvent->byteSize = sizeof(VstMidiEvent);
            pMidiEvent->deltaFrames = events[i].deltaFrames;
            pMidiEvent->detune = 0;
            pMidiEvent->flags = 1;
            pMidiEvent->noteLength = 0;
            pMidiEvent->noteOffset = 0;
            pMidiEvent->noteOffVelocity = 0;
            pMidiEvent->reserved1 = 0;
            pMidiEvent->reserved2 = 0;
            pMidiEvent->type = kVstMidiType;
            pMidiEvent->midiData[0] = events[i].data[0];
            memcpy( &pMidiEvent->midiData, &events[i].data, events[i].byteSize );
            pVstEvents->events[pVstEvents->numEvents++] = (VstEvent*)pMidiEvent;
        }
        return g_pAEffect->dispatcher( g_pAEffect, effProcessEvents, 0, 0, pVstEvents, 0 );
    }


    void __declspec(dllexport) ProcessReplacing( float** out_buffer, int frames ){
        g_pAEffect->processReplacing( g_pAEffect, NULL, out_buffer, frames );
    }


    int __declspec(dllexport) RenderToWaveW( WCHAR *path, unsigned int eof_clock ){
        g_cancelRequired = false;
        g_progress = 0.0;
        WAVEFORMATEX wf;
        wf.nChannels       = 2;
        wf.wFormatTag      = WAVE_FORMAT_PCM;
        wf.wBitsPerSample  = 16;
        wf.nBlockAlign     = wf.nChannels*wf.wBitsPerSample/8;
        wf.nSamplesPerSec  = g_sampleRate;// sampleFrames;
        wf.nAvgBytesPerSec = wf.nSamplesPerSec*wf.nBlockAlign;

        // Create WAV
        HMMIO hmmio = mmioOpenW( path, NULL, MMIO_CREATE | MMIO_WRITE | MMIO_EXCLUSIVE );
        MMCKINFO mmckRiff, mmckData, mmckFmt;
        mmckRiff.fccType = mmioStringToFOURCCW( L"WAVE", 0 );
        mmioCreateChunk( hmmio, &mmckRiff, MMIO_CREATERIFF );
        mmckFmt.ckid = mmioStringToFOURCCW( L"fmt ", 0 );
        mmioCreateChunk( hmmio, &mmckFmt, 0 );
        mmioWrite( hmmio, (char*)&wf, sizeof(WAVEFORMATEX) );
        mmioAscend( hmmio, &mmckFmt, 0 );

        mmckData.ckid = mmioStringToFOURCCW( L"data", 0 );
        mmioCreateChunk( hmmio, &mmckData, 0 );

        MIDI_EVENT *lpEvents = merge_events( g_ppTrackEvents[0], g_ppTrackEvents[1] );
        MIDI_EVENT* current = lpEvents;

        float* left_ch = new float[g_sampleRate];
        float* right_ch = new float[g_sampleRate];
        float* out_buffer[] = { left_ch, right_ch };

        DWORD* wave_bufs;
        wave_bufs = new DWORD[g_sampleRate];

        g_pAEffect->dispatcher( g_pAEffect, effSetSampleRate, 0, 0, 0, (float)g_sampleRate );//dispatch_VST_command(effSetSampleRate, 0, 0, 0, kSampleRate);
        g_pAEffect->dispatcher( g_pAEffect, effMainsChanged, 0, 1, 0, 0 );// dispatch_VST_command(effMainsChanged, 0, 1, 0, 0);
        // ł̓ubNTCYTvO[gƂƂɂ
        g_pAEffect->dispatcher( g_pAEffect, effSetBlockSize, 0, g_sampleRate, 0, 0 );// dispatch_VST_command(effSetBlockSize, 0, sampleFrames, 0, 0);

        int cur_buf = 0;

        DWORD dwTempo = 500000;

        int delay = 0;
        int duration = 0;
        DWORD dwNow = 0;
        DWORD dwPrev = 0;
        DWORD dwDelta;
        DWORD dwDelay = 0;
        DWORD dwDeltaDelay = 0;

        int addr_msb, addr_lsb;
        int data_msb, data_lsb;

#ifdef _DEBUG
        for( int i = 0; i < 1; i++ ){
            printf( "***********************************************************************\n" );
            MIDI_EVENT *pDebugWork = g_ppTrackEvents[i];
            while( pDebugWork ){
                printf( "    " );
                printf( "clock=%i;", pDebugWork->clock );
                for( int j = 0; j < pDebugWork->dwDataSize; j++ ){
                    printf( " 0x%02X", pDebugWork->pMidiEvent[j] );
                }
                pDebugWork = pDebugWork->pNext;
                printf( "\n" );
            }
        }
        int total_processed = 0;
#endif

        MIDI_EVENT* pWork = g_ppTrackEvents[1];
        //int eof_clock = 0;
        while( !dwDelay && pWork ){
	        // Delay̎擾
	        if( (pWork->pMidiEvent[0] & 0xf0) == 0xb0 ){
		        switch( pWork->pMidiEvent[1] ){
			        case 0x63:
				        addr_msb = pWork->pMidiEvent[2];
				        addr_lsb = 0;
				        break;
			        case 0x62:
				        addr_lsb = pWork->pMidiEvent[2];
				        break;
			        case 0x06:
				        data_msb = pWork->pMidiEvent[2];
				        break;
			        case 0x26:
				        data_lsb = pWork->pMidiEvent[2];
				        if( addr_msb == 0x50 && addr_lsb == 0x01 ){
                            delay = data_msb << 7 | data_lsb;
#ifdef _DEBUG
                            printf( "delay=%i\n", delay );
#endif
                            dwDelay = (DWORD)(delay * (double)g_sampleRate / 1000.0);
				        }
				        break;
		        }
            } /*else if ( pWork->pMidiEvent[0] == 0xff && pWork->pMidiEvent[1] == 0x2f && pWork->pMidiEvent[2] == 0x00 ) {
                eof_clock = pWork->clock;
#ifdef _DEBUG
                printf( "eof_clock=%i\n", eof_clock );
#endif
            }*/
	        pWork = pWork->pNext;
        }

        while( -1 ){
            if ( g_cancelRequired ) {
                mmioAscend( hmmio, &mmckRiff, 0 );
                mmioClose( hmmio, 0 );
                return FALSE;
            }
#ifdef _DEBUG
            printf( "-----------------------------------------------------------------------\n" );
#endif
            MIDI_EVENT* pProcessEvent = current;
            int nEvents = 0;

            while( current->clock == dwNow ){
	            if( current->pMidiEvent[0] == 0xFF ){
		            //^Cxg̏
		            switch( current->pMidiEvent[1] ){
			            case 0x51:
				            dwTempo = (DWORD)(current->pMidiEvent[5] | (current->pMidiEvent[4] << 8) | (current->pMidiEvent[3] << 16));
				            break;
		            }
	            }

	            // duration擾
	            if( (current->pMidiEvent[0] & 0xf0) == 0xb0 ){
                    switch( current->pMidiEvent[1] ){
			            case 0x63:
				            addr_msb = current->pMidiEvent[2];
				            addr_lsb = 0;
				            break;
			            case 0x62:
				            addr_lsb = current->pMidiEvent[2];
				            break;
			            case 0x06:
				            data_msb = current->pMidiEvent[2];
				            break;
			            case 0x26:
				            data_lsb = current->pMidiEvent[2];
				            // Note Duration in millisec
				            if( addr_msb == 0x50 && addr_lsb == 0x4 ){
//					            length = data_msb << 7 | addr_lsb;
                                duration = data_msb << 7 | data_lsb;
#ifdef _DEBUG
                                printf( "duration=%i\n", duration );
#endif
                            }
				            break;
		            }
	            }

	            nEvents++;
	            current = current->pNext;
                if( !current ){
		            break;
                }
            }

            if( !current ){
		        break;
            }

#ifdef _DEBUG
            printf( "nEvents=%i\n", nEvents );
#endif
            double msNow = totalMilliSec_from_timeCode( dwNow );
            double msPrev = totalMilliSec_from_timeCode( dwPrev );
            //double dt = DeltaToMilliSecond( dwNow - dwPrev, dwTempo );
            double dt = msNow - msPrev;
	        dwDelta = (DWORD)(dt * g_sampleRate / 1000.0);
#ifdef _DEBUG
            printf( "eof_clock=%i\n", eof_clock );
            printf( "dwNow=%i\n", dwNow );
            printf( "dwPrev=%i\n", dwPrev );
            printf( "dt=%f\n", dt );
            printf( "dwDelta=%i\n", dwDelta );
#endif

	        VstEvents* pVSTEvents = (VstEvents*)malloc( sizeof(VstEvents) + nEvents * sizeof(VstEvent*) );
	        pVSTEvents->numEvents = 0;
	        pVSTEvents->reserved = NULL;

	        for( int i = 0 ; i < nEvents ; i++ ){
		        BYTE event_code = pProcessEvent->pMidiEvent[0];
		        VstEvent* pVSTEvent = NULL;
		        VstMidiEvent* pMidiEvent;

		        switch( event_code ){
			        case 0xff:
                        break;
			        case 0xf0:
			        case 0xf7:
				        /*pSysexEvent = new VstMidiSysexEvent;
				        pSysexEvent->byteSize = sizeof(VstMidiSysexEvent);
				        pSysexEvent->type = kVstSysExType;
				        pSysexEvent->deltaFrames = dwDelta;
				        pSysexEvent->sysexDump = (char*)malloc(pSysexEvent->dumpBytes);
				        pSysexEvent->sysexDump[0] = event_code;
				        memcpy(&pSysexEvent->sysexDump[1],
					           &pProcessEvent->pMidiEvent[getVariableValue(&pProcessEvent->pMidiEvent[1],&dwLength)+1],
					           pSysexEvent->dumpBytes-1);
				        pSysexEvent->dumpBytes = dwLength + 1;
				        pSysexEvent->flags = 0;	 // reserved?
				        pSysexEvent->resvd1 = 0; // reserved?
				        pSysexEvent->resvd2 = 0; // reserved?
				        pVSTEvents->events[pVSTEvents->numEvents++] = (VstEvent*)pSysexEvent;*/
				        break;
			        default:
				        pMidiEvent = (VstMidiEvent*)malloc( sizeof(VstMidiEvent) + pProcessEvent->dwDataSize * sizeof(BYTE) );
				        pMidiEvent->byteSize = sizeof(VstMidiEvent);
				        pMidiEvent->deltaFrames = dwDelta;
				        pMidiEvent->detune = 0;
				        pMidiEvent->flags = 1;
				        pMidiEvent->noteLength = 0;
				        pMidiEvent->noteOffset = 0;
				        pMidiEvent->noteOffVelocity = 0;
				        pMidiEvent->reserved1 = 0;
				        pMidiEvent->reserved2 = 0;
				        pMidiEvent->type = kVstMidiType;
				        memcpy( &pMidiEvent->midiData, &pProcessEvent->pMidiEvent[pProcessEvent->dwOffset], pProcessEvent->dwDataSize );
				        pVSTEvents->events[pVSTEvents->numEvents++] = (VstEvent*)pMidiEvent;
				        break;
		        }
		        pProcessEvent = pProcessEvent->pNext;
	        }
	        g_pAEffect->dispatcher( g_pAEffect, effProcessEvents, 0, 0, pVSTEvents, 0 );

	        for( int i = 0 ; i < pVSTEvents->numEvents ; i++ ){
		        if( pVSTEvents->events[i]->type == kVstSysExType ){
			        VstMidiSysexEvent* pSysexEvent = (VstMidiSysexEvent*)pVSTEvents->events[i];
			        free( pSysexEvent->sysexDump );
		        }
	        }

	        while( dwDelta ){
                if ( g_cancelRequired ) {
                    mmioAscend( hmmio, &mmckRiff, 0 );
                    mmioClose( hmmio, 0 );
                    return FALSE;
                }
		        DWORD dwFrames = dwDelta > (DWORD)g_sampleRate ?  (DWORD)g_sampleRate : dwDelta;
		        g_pAEffect->processReplacing( g_pAEffect, NULL, out_buffer, dwFrames );
		        for( size_t j = 0 ; j < dwFrames; j++ ){
			        WORD right_chx = (WORD)(32768 * out_buffer[0][j]);
			        WORD left_chx = (WORD)(32768 * out_buffer[1][j]);
			        wave_bufs[j] = MAKELONG( right_chx, left_chx );
		        }
        		
		        int iOffset = dwDelay - dwDeltaDelay;
                if( iOffset > (int)dwFrames ){
			        iOffset = (int)dwFrames;
                }
		        if( !iOffset ){
			        mmioWrite( hmmio, (char*)wave_bufs, dwFrames * sizeof(DWORD) );
			        mmioAscend( hmmio, &mmckData, 0 );
                }else{
			        dwDeltaDelay += iOffset;
                }
#ifdef _DEBUG
                    total_processed += dwFrames;
#endif
		        dwDelta -= dwFrames;
	        }

	        free( pVSTEvents );

	        dwPrev = dwNow;
	        dwNow = current->clock;
            g_progress = dwNow / (double)eof_clock * 100.0;
        }

#ifdef _DEBUG
        printf( "dwDeltaDelay=%i\n", dwDeltaDelay );
#endif
//        dwDelta = g_sampleRate * (double)length / 1000.0 + dwDeltaDelay;
        double msLast = totalMilliSec_from_timeCode( dwNow );
        double msEof = totalMilliSec_from_timeCode( eof_clock );
        double msRemain = msEof - msLast;
        msRemain = (msRemain < 0.0) ? 0.0 : msRemain;
        DWORD dwDeltaDraft = (DWORD)(g_sampleRate * msRemain / 1000.0);
        dwDelta = (DWORD)(g_sampleRate * ((double)duration + (double)delay) / 1000.0 + dwDeltaDelay);
#ifdef _DEBUG
        printf( "dwDeltaDraft=%i\n", dwDeltaDraft );
        printf( "dwDelta=%i\n", dwDelta );
#endif
        dwDelta = (dwDelta > dwDeltaDraft) ? dwDelta : dwDeltaDraft;
        while( dwDelta ){
            if ( g_cancelRequired ) {
                mmioAscend( hmmio, &mmckRiff, 0 );
                mmioClose( hmmio, 0 );
                return FALSE;
            }
	        DWORD dwFrames = dwDelta > (DWORD)g_sampleRate ?  (DWORD)g_sampleRate : dwDelta;
	        g_pAEffect->processReplacing( g_pAEffect, NULL, out_buffer, dwFrames );
	        for( size_t j = 0 ; j < dwFrames; j++ ){
		        WORD right_chx = (WORD)(32768 * out_buffer[0][j]);
		        WORD left_chx = (WORD)(32768 * out_buffer[1][j]);
		        wave_bufs[j] = MAKELONG( right_chx, left_chx );
	        }

	        mmioWrite( hmmio, (char*)wave_bufs, dwFrames * sizeof(DWORD) );
	        mmioAscend( hmmio, &mmckData, 0 );

	        dwDelta -= dwFrames;
#ifdef _DEBUG
            total_processed += dwFrames;
#endif
        }

        g_pAEffect->dispatcher( g_pAEffect, effMainsChanged, 0, 0, 0, 0 );

        mmioAscend( hmmio, &mmckRiff, 0 );
        mmioClose( hmmio, 0 );

        free_events( lpEvents );
        delete [] left_ch;
        delete [] right_ch;
        delete [] wave_bufs;
#ifdef _DEBUG
        printf( "total_processed=%i\n", total_processed );
#endif

        return TRUE;
    }


    /*int __declspec(dllexport) RenderFirst( int *outL, int *outR, int sampleFrames ){
#ifdef _DEBUG
        printf( "RenderFirst\n" );
#endif
        int tcNext;  // g_tcCurrentƂȂׂlBRenderFirst𔲂钼Og_tcCurrentɓ

#ifdef _DEBUG
        // g_tempoList̃`FbN
        printf( "    CECKING TEMPO INFO\n" );
        printf( "        g_numTempoList=%i\n", g_numTempoList );
        printf( "           clock    tempo total_sec\n" );
        for( int i = 0; i < g_numTempoList; i++ ){
            printf( "        %8i %8i %f\n", g_tempoList[i].Clock, g_tempoList[i].Tempo, g_tempoList[i].TotalSec );
        }
        printf( "    DONE\n" );
#endif

        // Mains ChangedӖ͒mȂ
        g_pAEffect->dispatcher( g_pAEffect, effSetSampleRate, 0, 0, 0, (float)g_sampleRate );
        g_pAEffect->dispatcher( g_pAEffect, effMainsChanged, 0, 1, 0, 0 );
        g_pAEffect->dispatcher( g_pAEffect, effSetBlockSize, 0, g_saBlockSize, 0, 0 );

        // e|ƃC̃Cxg
        MIDI_EVENT *pMerged = merge_events( g_ppTrackEvents[0], g_ppTrackEvents[1] );

        // NbNg_tcCurrent(=0)łCxǧJEg
        MIDI_EVENT *pWork = pMerged;
        int numEvents = 0;
#ifdef _DEBUG
        printf( "    COUNTING THE NUMBER OF FIRST EVENTS\n" );
        printf( "        g_tcCurrent=%i\n", g_tcCurrent );
#endif
        while( pWork ){
            if( pWork->clock == g_tcCurrent ){
                numEvents++;
            }else if( pWork->clock > g_tcCurrent ){
                tcNext = pWork->clock;
                break;
            }
            pWork = pWork->pNext;
        }
#ifdef _DEBUG
        printf( "        numEvents=%i\n", numEvents );
        printf( "    DONE\n" );
#endif

        // ŏɑMVstEvents̏
#ifdef _DEBUG
        printf( "    PREPARING FIRST VST EVENTS\n" );
#endif
        VstEvents* pToBeProcessed = (VstEvents*)malloc( sizeof(VstEvents) + numEvents * sizeof(VstEvent*) );
        pToBeProcessed->numEvents = 0;
        pToBeProcessed->reserved = 0;

        // ̃Cxgf[^MɂA_OKvt[̌
        double start = totalMilliSec_from_timeCode( g_tcPrevious );
        double end = totalMilliSec_from_timeCode( g_tcCurrent );
        g_saTotalSamples = (int)((end - start) * g_sampleRate / 1000.0);
#ifdef _DEBUG
        printf( "        g_saTotalSamples=%i\n", g_saTotalSamples );
#endif

        pWork = pMerged;
        while( pWork ){
            VstMidiEvent *pVstMidiEvent;
            if( pWork->clock == g_tcCurrent ){
                pVstMidiEvent = (VstMidiEvent*)malloc( sizeof(VstMidiEvent) + pWork->dwDataSize * sizeof(unsigned char) );
                pVstMidiEvent->byteSize = sizeof(VstMidiEvent);
                pVstMidiEvent->deltaFrames = g_saTotalSamples;
                pVstMidiEvent->detune = 0;
                pVstMidiEvent->flags = 1;
                pVstMidiEvent->noteLength = 0;
                pVstMidiEvent->noteOffset = 0;
                pVstMidiEvent->noteOffVelocity = 0;
                pVstMidiEvent->reserved1 = 0;
                pVstMidiEvent->reserved2 = 0;
                pVstMidiEvent->type = kVstMidiType;
                memcpy( &pVstMidiEvent->midiData, &pWork->pMidiEvent[0], pWork->dwDataSize );
                pToBeProcessed->events[pToBeProcessed->numEvents++] = (VstEvent*)pVstMidiEvent;
            }
            pWork = pWork->pNext;
        }
#ifdef _DEBUG
        printf( "    DONE\n" );
#endif

        // ŏ̃Cxg𑗐M
#ifdef _DEBUG
        printf( "    PROCESS FIRST EVENTS\n" );
#endif
        g_pAEffect->dispatcher( g_pAEffect, effProcessEvents, 0, 0, pToBeProcessed, 0 );
#ifdef _DEBUG
        printf( "    DONE\n" );
#endif

        // ŏ̃_OBf^0ǁAKvH
        int saProcessNow = (sampleFrames < g_saTotalSamples) ? g_saTotalSamples : sampleFrames; 
        float *out0 = new float[saProcessNow];
        float *out1 = new float[saProcessNow];
        memset( out0, 0, saProcessNow * sizeof(float) );
        memset( out1, 0, saProcessNow * sizeof(float) );
        float *buffer[] = { out0, out1 };
        g_pAEffect->processReplacing( g_pAEffect, NULL, buffer, saProcessNow );

        // n
        g_tcPrevious = g_tcCurrent;
        g_tcCurrent = tcNext;
        free( pToBeProcessed );

        // 2ڂ̃CxǧJEg
#ifdef _DEBUG
        printf( "    COUNTING THE NUMBER OF SECOND EVNET\n" );
#endif
        numEvents = 0;
        pWork = pMerged;
        while( pWork ){
            if( pWork->clock == g_tcCurrent ){
                numEvents++;
            }else if( pWork->clock > g_tcCurrent ){
                tcNext = pWork->clock;
                break;
            }
            pWork = pWork->pNext;
        }
#ifdef _DEBUG
        printf( "        numEvents=%i\n", numEvents );
        printf( "    DONE\n" );
#endif

        // 2Ԗڂ̃Cxg
#ifdef _DEBUG
        printf( "    PREPARING SECOND VST EVENTS\n" );
#endif
        pToBeProcessed = (VstEvents*)malloc( sizeof(VstEvents) + numEvents * sizeof(VstEvent*) );
        pToBeProcessed->numEvents = 0;
        pToBeProcessed->reserved = 0;

        // 2Ԗڂ̃Cxgf[^MɂA_OKvt[̌
        start = totalMilliSec_from_timeCode( g_tcPrevious );
        end = totalMilliSec_from_timeCode( g_tcCurrent );
        g_saTotalSamples = (int)((end - start) * g_sampleRate / 1000.0);
#ifdef _DEBUG
        printf( "        g_saTotalSamples=%i\n", g_saTotalSamples );
#endif
        pWork = pMerged;
        while( pWork ){
            VstMidiEvent *pVstMidiEvent;
            if( pWork->clock == g_tcCurrent ){
                pVstMidiEvent = (VstMidiEvent*)malloc( sizeof(VstMidiEvent) + pWork->dwDataSize * sizeof(unsigned char) );
                pVstMidiEvent->byteSize = sizeof(VstMidiEvent);
                pVstMidiEvent->deltaFrames = g_saTotalSamples;
                pVstMidiEvent->detune = 0;
                pVstMidiEvent->flags = 1;
                pVstMidiEvent->noteLength = 0;
                pVstMidiEvent->noteOffset = 0;
                pVstMidiEvent->noteOffVelocity = 0;
                pVstMidiEvent->reserved1 = 0;
                pVstMidiEvent->reserved2 = 0;
                pVstMidiEvent->type = kVstMidiType;
                memcpy( &pVstMidiEvent->midiData, &pWork->pMidiEvent[0], pWork->dwDataSize );
                pToBeProcessed->events[pToBeProcessed->numEvents++] = (VstEvent*)pVstMidiEvent;
            }
            pWork = pWork->pNext;
        }
#ifdef _DEBUG
        printf( "    DONE\n" );
#endif

        // 2Ԗڂ̃Cxg𑗐M
#ifdef _DEBUG
        printf( "    PROCESS SECOND EVENTS\n" );
#endif
        g_pAEffect->dispatcher( g_pAEffect, effProcessEvents, 0, 0, pToBeProcessed, 0 );
#ifdef _DEBUG
        printf( "    DONE\n" );
#endif

#ifdef _DEBUG
        printf( "    RENDERING\n" );
#endif
        // 񃌃_OTv߂
        saProcessNow = (sampleFrames < g_saTotalSamples) ? g_saTotalSamples : sampleFrames; 
#ifdef _DEBUG
        printf( "        saProcessNow=%i\n", saProcessNow );
#endif

        // _O
        memset( out0, 0, saProcessNow * sizeof(float) );
        memset( out1, 0, saProcessNow * sizeof(float) );
        g_pAEffect->processReplacing( g_pAEffect, NULL, buffer, saProcessNow );
#ifdef _DEBUG
        printf( "    DONE\n" );
#endif

        // ʂRs[
#ifdef _DEBUG
        printf( "    COPYING RESULTS\n" );
#endif
        for( int i = 0; i < saProcessNow; i++ ){
            int iL = (int)(32768 * buffer[0][i]);
            int iR = (int)(32768 * buffer[1][i]);
#ifdef _DEBUG
            printf( "%f  %f\n", buffer[0][i], buffer[1][i] );
            fprintf( g_debug_wave, "%i\t%i\n", iL, iR );
#endif
            *outL++ = iL;
            *outR++ = iR;
        }
#ifdef _DEBUG
        printf( "    DONE\n" );
#endif

        g_tcPrevious = g_tcCurrent;
        g_tcCurrent = tcNext;

        g_saProcessed = saProcessNow;
        return g_saTotalSamples - saProcessNow;
    }*/


    int __declspec(dllexport) LoadPluginA( char *name, int blockSize, int sampleRate ){
        HMODULE dll_handle = LoadLibraryA( name );
        int ret = FALSE;
        try{
            ret = LoadPluginCore( dll_handle, blockSize, sampleRate );
        } catch( const char* str ) {
            ret = FALSE;
        }
        return ret;
    }

    
    int __declspec(dllexport) LoadPluginW( WCHAR *name, int blockSize, int sampleRate ){
        HMODULE dll_handle = LoadLibraryW( name );
        int ret = FALSE;
        try{
            ret = LoadPluginCore( dll_handle, blockSize, sampleRate );
        } catch( const char* str ) {
            ret = FALSE;
        }
        return ret;
    }


    int __declspec(dllexport) SendEvent( unsigned char *src, int *deltaFrames, int numEvents, int targetTrack ){
        int count;
        if( targetTrack == 0 ){
            if( g_tempoList ){
                delete [] g_tempoList;
            }
            if( numEvents <= 0 ){
                g_numTempoList = 1;
                g_tempoList = new TempoInfo[1];
                g_tempoList[0].Clock = 0;
                g_tempoList[0].Tempo = DEF_TEMPO;
                g_tempoList[0].TotalSec = 0.0;
            }else{
                int index_offset;
                if( deltaFrames[0] == 0 ){
                    g_numTempoList = numEvents;
                    g_tempoList = new TempoInfo[numEvents];
                    index_offset = 0;
                }else{
                    g_numTempoList = numEvents + 1;
                    g_tempoList = new TempoInfo[numEvents + 1];
                    index_offset = 1;
                    g_tempoList[0].Clock = 0;
                    g_tempoList[0].Tempo = DEF_TEMPO;
                    g_tempoList[0].TotalSec = 0.0;
                }
                int tempo_prev = DEF_TEMPO;
                int tempo_clock = 0;
                double total = 0.0;
                count = -3;
                for( int i = 0; i < numEvents; i++ ){
                    count += 3;
                    int tempo = (int)(src[count + 2] | (src[count + 1] << 8) | (src[count] << 16));
                    g_tempoList[i + index_offset].Clock = deltaFrames[i];
                    g_tempoList[i + index_offset].Tempo = tempo;
                    total += (deltaFrames[i] - tempo_clock) * (double)tempo_prev / (1000.0 * TIME_FORMAT);
                    g_tempoList[i + index_offset].TotalSec = total;
                    tempo_prev = tempo;
                    tempo_clock = deltaFrames[i];
                }
            }
        }

        // ^ꂽCxgg_ppTrackEventsɎ[
        count = -3;
        MIDI_EVENT *pPrev = NULL;
        for( int i = 0; i < numEvents; i++ ){
            count += 3;
            MIDI_EVENT *pEvent;
            pEvent = NULL;
            pEvent = new MIDI_EVENT;
            pEvent->pNext = NULL;
            pEvent->clock = deltaFrames[i];
            pEvent->dwOffset = 0;
            if( targetTrack == 0 ){
                pEvent->dwDataSize = 6;
                pEvent->pMidiEvent = new unsigned char[6];
                pEvent->pMidiEvent[0] = 0xff;
                pEvent->pMidiEvent[1] = 0x51;
                pEvent->pMidiEvent[2] = 0x03;
                pEvent->pMidiEvent[3] = src[count];
                pEvent->pMidiEvent[4] = src[count + 1];
                pEvent->pMidiEvent[5] = src[count + 2];
            }else{
                pEvent->dwDataSize = 4;
                pEvent->pMidiEvent = new unsigned char[4];
                pEvent->pMidiEvent[0] = src[count];
                pEvent->pMidiEvent[1] = src[count + 1];
                pEvent->pMidiEvent[2] = src[count + 2];
                pEvent->pMidiEvent[3] = 0x00;
            }
            if( pPrev ){
                pPrev->pNext = pEvent;
            }else{
                g_ppTrackEvents[targetTrack] = pEvent;
            }
            pPrev = pEvent;
        }

        return TRUE;
    }


    int __declspec(dllexport) FreePlugin(){
        if( g_pAEffect ){
            g_pAEffect->dispatcher( g_pAEffect, effClose, 0, 0, 0, 0 );
        }
        //free_smf();
        return TRUE;
#ifdef _DEBUG
        if( g_debug_wave ){
            fclose( g_debug_wave );
        }
#endif
    }

} // extern "C"


int free_events( MIDI_EVENT* pEvent ){
    MIDI_EVENT* pEventTmp;
    while( pEvent ){
	    pEventTmp = pEvent->pNext;
	    delete pEvent->pMidiEvent;
	    delete pEvent;
	    pEvent = pEventTmp;
    }
    return TRUE;
}


MIDI_EVENT* merge_events( MIDI_EVENT* x0,MIDI_EVENT* y0 ){
	MIDI_EVENT *x = copy_event( x0 );
	MIDI_EVENT *y = copy_event( y0 );
	MIDI_EVENT z;
	MIDI_EVENT *p = &z;

	while( x && y ){
		if( x->clock <= y->clock ){
			p->pNext = x;
			p = x;
			x = x->pNext;
		}else{
			p->pNext = y;
			p = y;
			y = y->pNext;
		}
	}
	
    if( x ){
        p->pNext = x;
    }else{
		p->pNext = y;
    }
	
	return z.pNext;
}


MIDI_EVENT* copy_event( MIDI_EVENT* x ){
	MIDI_EVENT z;
	MIDI_EVENT *p = &z;

	while( x ){
		p->pNext = clone_event( x );
		p = p->pNext;
		x = x->pNext;
	}
	
	return z.pNext;
}


MIDI_EVENT* clone_event( MIDI_EVENT* pEvent ){
	MIDI_EVENT* pNewEvent = new MIDI_EVENT;
	pNewEvent->clock = pEvent->clock;
	pNewEvent->dwDataSize = pEvent->dwDataSize;
	pNewEvent->dwOffset	= pEvent->dwOffset;
	pNewEvent->pMidiEvent = new unsigned char[pEvent->dwDataSize + pEvent->dwOffset];
	memcpy( pNewEvent->pMidiEvent, pEvent->pMidiEvent, pEvent->dwDataSize + pEvent->dwOffset );
	pNewEvent->pNext = NULL;
	return pNewEvent;
}


/// <summary>
/// w肵^CR[hɂCȓ瑪Ԃ𒲂ׂ
/// </summary>
double totalMilliSec_from_timeCode( int timeCode ){
    double ret = 0.0;
    int index = -1;
    for( int i = 0; i < g_numTempoList; i++ ){
        if( timeCode <= g_tempoList[i].Clock ){
            break;
        }
        index = i;
    }
    if( index >= 0 ){
        ret = g_tempoList[index].TotalSec + (timeCode - g_tempoList[index].Clock) * (double)g_tempoList[index].Tempo / (1000.0 * TIME_FORMAT);
    }else{
        ret = timeCode * (double)DEF_TEMPO / (1000.0 * TIME_FORMAT);
    }
    return ret;
}


double timeCode_from_totalMilliSec( double totalMilliSec ){
    double ret = 0.0;
    int index = -1;
    for( int i = 0; i < g_numTempoList; i++ ){
        if( totalMilliSec <= g_tempoList[i].TotalSec ){
            break;
        }
        index = i;
    }
    if( index >= 0 ){
        double dt = totalMilliSec - g_tempoList[index].TotalSec;
        int tempo = g_tempoList[index].Tempo;
        int clock = g_tempoList[index].Clock;
        ret = clock + (dt * 1000.0 * TIME_FORMAT) / (double)tempo;
    }else{
        ret = totalMilliSec * 1000.0 * TIME_FORMAT / (double)DEF_TEMPO;
    }
    return ret;
}


VstIntPtr AudioMaster( AEffect* effect, VstInt32 opcode, VstInt32 index, VstIntPtr value, void* ptr, float opt ){
	VstIntPtr result = 0;

	switch( opcode ){
		case audioMasterVersion :
			result = kVstVersion;
			break;
	}
	return result;
}


int LoadPluginCore( HMODULE dllHandle, int blockSize, int sampleRate ){
    g_saBlockSize = blockSize;
    g_sampleRate = sampleRate;
    g_dllHandle = dllHandle;

	PVSTMAIN main;// = (PVSTMAIN)GetProcAddress( g_dllHandle, "VSTPluginMain" );
    //if( !main ){
        main = (PVSTMAIN)GetProcAddress( g_dllHandle, "main" );
    //}

    if( !main ){
        return FALSE;
    }

    g_pAEffect = main( AudioMaster );
    g_pAEffect->dispatcher( g_pAEffect, effOpen, 0, 0, 0, 0 );
    g_pAEffect->dispatcher( g_pAEffect, effSetSampleRate, 0, 0, 0, (float)g_sampleRate );
    g_pAEffect->dispatcher( g_pAEffect, effSetBlockSize, 0, g_saBlockSize, 0, 0 );

    g_ppTrackEvents = new MIDI_EVENT*[NUM_TRACKS];
#ifdef _DEBUG
    g_debug_wave = fopen( "wave_raw.log", "w" );
#endif
    return TRUE;
}


/*int _tmain( int argc, _TCHAR* argv[] ){
#ifdef _DEBUG
    const int BLOCK_SIZE = 88200;
    const int SAMPLE_RATE = 44100;

    // dllǍ
    printf( "@LoadPlugin\n" );
    int ret = LoadPlugin( TEXT("C:\\Program Files\\Steinberg\\VSTplugins\\VOCALOID2\\VOCALOID2.dll"), BLOCK_SIZE, SAMPLE_RATE );
//    int ret = LoadPlugin( TEXT("C:\\cvs\\VECapture+\\VSTi\\Release\\interpreter.dll"), BLOCK_SIZE, SAMPLE_RATE ); 
//    int ret = LoadPlugin( TEXT("C:\\Program Files\\Steinberg\\VSTplugins\\Synth1 VST.dll" ), BLOCK_SIZE, SAMPLE_RATE );
    if( !ret ){
        printf( "    @failed\n" );
        return 0;
    }else{
        printf( "    @successed\n" );
    }

    for( int k = 0; k < 3; k++ ){

    // ܂e|AgbN0ɑM
    printf( "@SendEvent [tempo]\n" );
    unsigned char *masterEvents = new unsigned char[1 * 3];
    masterEvents[0] = 0x07;
    masterEvents[1] = 0xa1;
    masterEvents[2] = 0x20;
    int *masterClocks = new int[1];
    masterClocks[0] = 0;
    ret = SendEvent( masterEvents, masterClocks, 1, 0 );
    if( !ret ){
        printf( "    @failed\n" );
        return 0;
    }else{
        printf( "    @successed\n" );
    }

    // f[^{̂𑗐M
    printf( "@SendEvent [body]\n" );
    unsigned char *bodyEvents = new unsigned char[debug_numEvents * 3];
    int count = -3;
    for( int i = 0; i < debug_numEvents; i++ ){
        count += 3;
        bodyEvents[count] = debug_midiDataList[i][0];
        bodyEvents[count + 1] = debug_midiDataList[i][1];
        bodyEvents[count + 2] = debug_midiDataList[i][2];
    }
    ret = SendEvent( bodyEvents, deltaFrameList, debug_numEvents, 1 );
    if( !ret ){
        printf( "    @failed\n" );
        return 0;
    }else{
        printf( "    @successed\n" );
    }

    // ŏ̉_O
    //printf( "@RenderFirst\n" );
    //int *outL = new int[BLOCK_SIZE];
    //int *outR = new int[BLOCK_SIZE];
    //memset( outL, 0, BLOCK_SIZE * sizeof(int) );
    //memset( outR, 0, BLOCK_SIZE * sizeof(int) );
    //ret = RenderFirst( outL, outR, BLOCK_SIZE );
    //printf( "    ret=%i\n", ret );
	WCHAR tszOutput[MAX_PATH];
    wsprintf( tszOutput, TEXT("%i.wav"), k );
    RenderToWaveW( tszOutput );
    }

    // dll
    printf( "@FreePlugin\n" );
    ret = FreePlugin();
    if( !ret ){
        printf( "    @failed\n" );
        return 0;
    }else{
        printf( "    @successed\n" );
    }
#endif
    return 0;
}*/
