#ifndef __VSTi2h__
#define __VSTi2h__
#include "pluginterfaces/vst2.x/aeffectx.h"
#include <windows.h>
#include <tchar.h>
#include <stdio.h>
#include <mmsystem.h>
#pragma comment(lib,"winmm")

extern "C" {

    /// t@Cw肵ăvOCǂݍ
    int __declspec(dllexport) LoadPluginA( char *name, int blockSize, int sampleRate );
    /// t@Cw肵ăvOCǂݍ(jR[h)
    int __declspec(dllexport) LoadPluginW( WCHAR *name, int blockSize, int sampleRate );
    /// vOCJ
    int __declspec(dllexport) FreePlugin();
    /// vOCɑmidif[^w肷B
    int __declspec(dllexport) SendEvent( unsigned char *src, int *deltaFrames, int numEventsm, int targetTrack );
    /// 1̃_Oi߂B̃_ORenderContinueōsB߂ĺAc̃t[
    int __declspec(dllexport) RenderFirst( int *outL, int *outR, int sampleFrames );
    /// RenderFirstŃ_OoȂc̃̕_OsB߂ĺAc̃t[
    int __declspec(dllexport) RenderContinue( int *outL, int *outR, int sampleFrames );
    int __declspec(dllexport) RenderToWaveW( WCHAR *path, unsigned int eof_clock );
    int __declspec(dllexport) RenderToWaveA( char *path );
    int __declspec(dllexport) SetSampleRate( float sample_rate );
    int __declspec(dllexport) MainsChanged( int status );
    int __declspec(dllexport) SetBlockSize( int block_size );

} // extern "C"

inline int LoadPlugin( LPTSTR name, int blockSize, int sampleRate ){
#if UNICODE
    return LoadPluginW( name, blockSize, sampleRate );
#else
    return LoadPluginA( name, blockSize, sampleRate );
#endif
}

struct TempoInfo{
public:
    int Clock;          // e|ύX鎞\NbN
    int Tempo;          // e|
    double TotalSec;    // e|ύX鎞
};

typedef AEffect* (*PVSTMAIN)( audioMasterCallback audioMaster );

struct MIDI_EVENT{
public:
    unsigned int clock;
	MIDI_EVENT *pNext;
	unsigned int dwDataSize;
	unsigned char dwOffset;
    unsigned char* pMidiEvent;
};

int LoadPluginCore( HMODULE dll_handle, int blockSize, int sampleRate );
VstIntPtr AudioMaster( AEffect *effect, long opcode, long index, long value, void *ptr, float opt );
double totalMilliSec_from_timeCode( int timeCode );
double timeCode_from_totalMilliSec( double totalMilliSec );
MIDI_EVENT* merge_events( MIDI_EVENT* x0,MIDI_EVENT* y0 );
MIDI_EVENT* copy_event( MIDI_EVENT* x );
MIDI_EVENT* clone_event( MIDI_EVENT* pEvent );
int free_events( MIDI_EVENT* pEvent );

#endif // __VSTi2h__
